package bug14689126norowinconsistentexceptionapp.model.fwkextension;

import oracle.jbo.RowInconsistentException;
import oracle.jbo.server.AttributeDefImpl;
import oracle.jbo.server.ViewAttributeDefImpl;
import oracle.jbo.server.ViewRowImpl;

public class CustomerExtensionViewRowImpl
	extends ViewRowImpl
{

	protected void setAttributeInternal(int index, Object val)
	{
		// based on feedback from Steve Muench via SR 3-6322025251
		throwIfAttrBeingSetIsModifiedOnAndValueDoesNotMatchDBValue(index, val);
		super.setAttributeInternal(index, val);
	}

	/**
	 * Throw RowInconsistentException if attempt is made to set a ViewRow Modified-On history attribute
	 * that is also marked as the change indicator, whenever the original value read at the time of
	 * row querying (ORIGINAL_VERSION) is different from the value that is trying to be set on the
	 * attribute. This ViewRow attribute will only be set by ADF Faces and ADF Data Binding layer if
	 * the value sent in the ADF Faces form from the client (via the <tr:inputHidden>) is different
	 * from the underlying queried value, but we add in this additional conditional logic to make
	 * the mechanism bulletproof.
	 *
	 * @param index The index of the view row attribute being set
	 * @param newVal The new value to which this view row attribute should be set
	 */
	private void throwIfAttrBeingSetIsModifiedOnAndValueDoesNotMatchDBValue(
		int index, Object newVal)
	{
		System.out.println("CustomerExtensionViewRowImpl.throwIfAttrBeingSetIsModifiedOnAndValueDoesNotMatchDBValue()"
			+ " : index = " + index + ", newVal = " + newVal);
		if (newVal != null)
		{
			ViewAttributeDefImpl attrDef =
				(ViewAttributeDefImpl)getStructureDef().getAttributeDef(index);
			if (attrDef.getHistoryKind() == AttributeDefImpl.HISTORY_MODIFY_DATE)
			{
				AttributeDefImpl entityAttrDef = attrDef.getEntityAttributeDef();
				if (entityAttrDef != null && entityAttrDef.isChangeIndicatorColumn())
				{
					Object previousDBValue =
						getAttributeInternal(index, ORIGINAL_VERSION);
					System.out.println("CustomerExtensionViewRowImpl.throwIfAttrBeingSetIsModifiedOnAndValueDoesNotMatchDBValue()"
						+ " : newVal = " + newVal + ", previousDBValue = " + previousDBValue);
					if (previousDBValue != null)
					{
						if (!newVal.equals(previousDBValue))
						{
							throw new RowInconsistentException(getKey());
						}
					}
				}
			}
		}
	}
}
